#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <errno.h>
#include <math.h>

#define EMPEG_MIXER_MAGIC 'm'
#define EMPEG_MIXER_WRITE_FLAGS         _IOW(EMPEG_MIXER_MAGIC, 1, int)
#define EMPEG_MIXER_FLAG_MUTE           (1<<0)

#define EMPEG_DSP_MAGIC 'a'
#define EMPEG_DSP_BEEP _IOW(EMPEG_DSP_MAGIC, 0, int)
#define EMPEG_DSP_VOLADJ _IOW(EMPEG_DSP_MAGIC, 3, int)

int main(int ac, char *av[])
{
int fd;
int mixerfd;
int iores;
int args[5];
unsigned int mixerflags;

mixerfd = open("/dev/mixer", O_RDONLY);

if ( mixerfd == -1 ) {
    fprintf(stderr,"error opening Mixer device.");
} else {
    mixerflags = EMPEG_MIXER_FLAG_MUTE;
    iores = ioctl(mixerfd, EMPEG_MIXER_WRITE_FLAGS, &mixerflags) ;
    if (iores == -1) {
        fprintf(stderr, "result of mixer mute ioctl was: %d\n",iores);
        fprintf(stderr, "errno: %d\n",errno);
    }
}

fd = open("/dev/dsp", O_RDONLY);

if (mixerfd >= 0) {
    mixerflags = 0;
    iores = ioctl(mixerfd, EMPEG_MIXER_WRITE_FLAGS, &mixerflags) ;
    if (iores == -1) {
        fprintf(stderr, "result of mixer unmute ioctl was: %d\n",iores);
        fprintf(stderr, "errno: %d\n",errno);
    }
    close(mixerfd);
}

if (ac != 6) {
	fprintf(stderr,"Usage: voladj <factor/second> <minvol> <headroom> <real silence> <fake silence>\n");
	return 1;
	}

args[0] = atoi(av[1]);
args[1] = atoi(av[2]);
args[2] = atoi(av[3]);
args[3] = atoi(av[4]);
args[4] = atoi(av[5]);

if (fd < 0) {
	perror("Couldn't open /dev/dsp.\n");
	return 1;
	}
if (ioctl(fd, EMPEG_DSP_VOLADJ, args) < 0)
             perror("ioctl.\n");
close(fd);
return 0;
}
